<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 *
 *
 * a special type of 'cash on delivey':
 * @author Tarasiadis Miltos, easyTECH
 * @package VirtueMart
 * @subpackage payment
 * @copyright Copyright (C) 2004-2008 soeren - All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.net
 */
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentEasyvmsms extends vmPSPlugin {

    public static $_this = false;

    function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('easysms');
			$this->params = new JParameter( $plugin->params );
		}
	// self::$_this = $this;
    }

    function plgVmOnUpdateOrderPayment($orders,$old_order_status) {
    
   		//Get plugin params
		$from_id = $this->params->get('fromtext');
		$thanksmessage = $this->params->get('thanksmessage');
		$shoppernametext = $this->params->get('shoppernametext');
		$ordertext = $this->params->get('ordertext');
		$statustext = $this->params->get('statustext');
		$userfieldmobile = $this->params->get('userfieldmobile');
		$userfieldfirstname = $this->params->get('userfieldfirstname');
		$userfieldlastname = $this->params->get('userfieldlastname');
		
				if ($this->params->get('smsprovider') == 0) {
			$apikey = $this->params->get('clickatellapi');
			$clickatelluser = $this->params->get('clickatelluser');
			$clickatellpassword = $this->params->get('clickatellpassword');
			}	
		// Get Clickatell param
		if ($this->params->get('smsprovider') == 1) {
			$apikey = $this->params->get('clickatellapi');
			$clickatelluser = $this->params->get('clickatelluser');
			$clickatellpassword = $this->params->get('clickatellpassword');
			}
	
		$orderModel=VmModel::getModel('orders');
		$order = $orderModel->getOrder($orders->virtuemart_order_id);
	
		// Get the order status name
		$db = JFactory::getDBO();
		$q = 'SELECT `order_status_name` FROM `#__virtuemart_orderstates` WHERE `order_status_code`="'.$orders->order_status.'"';
		$db->setQuery($q);
		$statusName = $db->loadResult();	
		
		//dump($order);
		if (is_numeric($order['details']['BT']->{$userfieldmobile}))
		{
				
			$smsTEXT = urlencode ($thanksmessage." ".$shoppernametext." ".$order['details']['BT']->{$userfieldfirstname}." ".$order['details']['BT']->{$userfieldlastname}." ".$ordertext." ".$order['details']['BT']->virtuemart_order_id." ".$statustext." ".$statusName);	
			$ch = curl_init();
			// Apifon smsTEXT Construction
						
			if ($this->params->get('smsprovider') == 0) {
     			$smsURL = "http://185.4.28.180/class/sms/webservice/send_url.php?from=".$apikey."&to=".$order['details']['BT']->{$userfieldmobile}."&msg=".$smsTEXT."&uname=".$clickatelluser."&pass=".$clickatellpassword;
			}
			if ($this->params->get('smsprovider') == 1) {
     			$smsURL = "http://185.4.28.180/class/sms/webservice/send_url.php?from=".$apikey."&to=".$order['details']['BT']->{$userfieldmobile}."&msg=".$smsTEXT."&uname=".$clickatelluser."&pass=".$clickatellpassword;
			}
			
			
			curl_setopt($ch, CURLOPT_URL, $smsURL);
	 		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$output = curl_exec($ch);
	 		curl_close($ch);
		}
	}

    /*
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     * @author Valérie Isaksen
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
	return $this->onStoreInstallPluginTable($jplugin_id);
    } 
}

// No closing tag